Index: drivers/scsi/qla1280.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qla1280.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qla1280.c	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/qla1280.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -5724,104 +4570,92 @@
  *      done_q_first = done queue first pointer.
  *      done_q_last  = done queue last pointer.
  */
-STATIC void
-qla1280_status_entry(scsi_qla_host_t *ha, sts_entry_t *pkt, srb_t **done_q_first,
-                     srb_t **done_q_last)
-{
-    uint32_t        b, t, l;
-    uint8_t         sense_sz = 0;
-    srb_t           *sp;
-    scsi_lu_t       *q;
-    Scsi_Cmnd       *cp;
-
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_status_entry");
-#endif
-
-    /* Validate handle. */
-    if (pkt->handle < MAX_OUTSTANDING_COMMANDS)
-        sp = ha->outstanding_cmds[pkt->handle];
-    else
-        sp = 0;
-
-    if (sp)
-    {
-        /* Free outstanding command slot. */
-        ha->outstanding_cmds[pkt->handle] = 0;
-
-        cp = sp->cmd;
-        /* Generate LU queue on cntrl, target, LUN */
-        b = SCSI_BUS_32(cp);
-        t = SCSI_TCN_32(cp);
-        l = SCSI_LUN_32(cp);
-        q = LU_Q(ha, b, t, l);
-        if( pkt->comp_status || pkt->scsi_status )
-        {
-            DEBUG(qla1280_print( "scsi: comp_status = ");)
-            DEBUG(qla1280_output_number((uint32_t)pkt->comp_status,16);)
-            DEBUG(qla1280_print( ", ");)
-            DEBUG(qla1280_print( " scsi_status = ");)
-            DEBUG(qla1280_output_number((uint32_t)pkt->scsi_status,16);)
-            DEBUG(qla1280_print( "\n\r");)
-            DEBUG(qla1280_print(", handle = ");)
-            DEBUG(qla1280_output_number((uint32_t)pkt->handle, 16);)
-            DEBUG(qla1280_print("\n\r");)
-        }
-
-        /* Target busy */
-        if ( pkt->scsi_status & SS_BUSY_CONDITION &&
-            pkt->scsi_status != SS_RESERVE_CONFLICT   )
-        {
-            CMD_RESULT(cp) = (int) (DID_BUS_BUSY << 16) |
-                    (pkt->scsi_status & 0xff);
-        }
-        else
-        {
-
-            /* Save ISP completion status */
-            CMD_RESULT(cp) = qla1280_return_status( pkt, cp );
-
-            if (pkt->scsi_status & SS_CHECK_CONDITION)
-            {
-                BZERO(cp->sense_buffer, CMD_SNSLEN(cp));
-                if (pkt->comp_status != CS_ARS_FAILED)
-                {
-                    if ( pkt->req_sense_length < CMD_SNSLEN(cp)  )
-                        sense_sz = pkt->req_sense_length;
-                    else
-                        sense_sz = CMD_SNSLEN(cp) - 1;
-
-                    BCOPY((caddr_t)&pkt->req_sense_data, cp->sense_buffer, sense_sz);
-
-                }
-#ifdef QL_DEBUG_LEVEL_2
-                DEBUG(qla1280_print(
-                        "qla1280_status_entry: Check condition Sense data, b");)
-                DEBUG(qla1280_output_number((uint32_t)b, 10);)
-                DEBUG(qla1280_print("t");)
-                DEBUG(qla1280_output_number((uint32_t)t, 10);)
-                DEBUG(qla1280_print("d");)
-                DEBUG(qla1280_output_number((uint32_t)l, 10);)
-                DEBUG(qla1280_print("\n\r");)
-                DEBUG(if (sense_sz))
-                    DEBUG(qla1280_dump_buffer(cp->sense_buffer, sense_sz);)
-#endif
-            }
-        }
-        /* Place command on done queue. */
-        qla1280_done_q_put(sp, done_q_first, done_q_last);
-    }
-    else
-    {
-#ifdef QL_DEBUG_LEVEL_2
-        qla1280_print("qla1280_status_entry: ISP Invalid handle\n\r");
-#endif
-        printk(KERN_WARNING "qla1280: Status Entry invalid handle\n");
-        ha->flags.isp_abort_needed = TRUE;
-    }
-#ifdef QL_DEBUG_LEVEL_3
-    LEAVE("qla1280_status_entry");
-#endif
+static void
+qla1280_status_entry(struct scsi_qla_host *ha, struct response *pkt,
+		     struct srb **done_q_first, struct srb **done_q_last)
+{
+	unsigned int bus, target, lun;
+	int sense_sz;
+	struct srb *sp;
+	Scsi_Cmnd *cmd;
+	uint32_t handle = le32_to_cpu(pkt->handle);
+	uint16_t scsi_status = le16_to_cpu(pkt->scsi_status);
+	uint16_t comp_status = le16_to_cpu(pkt->comp_status);
+
+	ENTER("qla1280_status_entry");
+
+	/* Validate handle. */
+	if (handle < MAX_OUTSTANDING_COMMANDS)
+		sp = ha->outstanding_cmds[handle];
+	else
+		sp = NULL;
+
+	if (!sp) {
+		printk(KERN_WARNING "qla1280: Status Entry invalid handle\n");
+		goto out;
+	}
+
+	/* Free outstanding command slot. */
+	ha->outstanding_cmds[handle] = 0;
+
+	cmd = sp->cmd;
+
+	/* Generate LU queue on cntrl, target, LUN */
+	bus = SCSI_BUS_32(cmd);
+	target = SCSI_TCN_32(cmd);
+	lun = SCSI_LUN_32(cmd);
+
+	if (comp_status || scsi_status) {
+		dprintk(3, "scsi: comp_status = 0x%x, scsi_status = "
+			"0x%x, handle = 0x%x\n", comp_status,
+			scsi_status, handle);
+	}
+
+	/* Target busy */
+	if (scsi_status & SS_BUSY_CONDITION &&
+	    scsi_status != SS_RESERVE_CONFLICT) {
+		CMD_RESULT(cmd) =
+			DID_BUS_BUSY << 16 | (scsi_status & 0xff);
+	} else {
+
+		/* Save ISP completion status */
+		CMD_RESULT(cmd) = qla1280_return_status(pkt, cmd);
+
+		if (scsi_status & SS_CHECK_CONDITION) {
+			if (comp_status != CS_ARS_FAILED) {
+				uint16_t req_sense_length =
+					le16_to_cpu(pkt->req_sense_length);
+				if (req_sense_length < CMD_SNSLEN(cmd))
+					sense_sz = req_sense_length;
+				else
+					/*
+					 * Scsi_Cmnd->sense_buffer is
+					 * 64 bytes, why only copy 63?
+					 * This looks wrong! /Jes
+					 */
+					sense_sz = CMD_SNSLEN(cmd) - 1;
+
+				memcpy(cmd->sense_buffer,
+				       &pkt->req_sense_data, sense_sz);
+			} else
+				sense_sz = 0;
+			memset(cmd->sense_buffer + sense_sz, 0,
+			       sizeof(cmd->sense_buffer) - sense_sz);
+
+			dprintk(2, "qla1280_status_entry: Check "
+				"condition Sense data, b %i, t %i, "
+				"l %i\n", bus, target, lun);
+			if (sense_sz)
+				qla1280_dump_buffer(2,
+						    (char *)cmd->sense_buffer,
+						    sense_sz);
+		}
+	}
+	/* Place command on done queue. */
+	qla1280_done_q_put(sp, done_q_first, done_q_last);
+
+ out:
+	LEAVE("qla1280_status_entry");
 }
 
 /*
@@ -5834,71 +4668,55 @@
  *      done_q_first = done queue first pointer.
  *      done_q_last  = done queue last pointer.
  */
-STATIC void
-qla1280_error_entry(scsi_qla_host_t *ha, response_t *pkt, srb_t **done_q_first,
-                    srb_t **done_q_last)
-{
-    srb_t   *sp;
-
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_error_entry");
-#endif
-
-#ifdef QL_DEBUG_LEVEL_2
-    if (pkt->entry_status & BIT_3)
-        qla1280_print("qla1280_error_entry: BAD PAYLOAD flag error\n\r");
-    else if (pkt->entry_status & BIT_2)
-        qla1280_print("qla1280_error_entry: BAD HEADER flag error\n\r");
-    else if (pkt->entry_status & BIT_1)
-        qla1280_print("qla1280_error_entry: FULL flag error\n\r");
-    else
-        qla1280_print("qla1280_error_entry: UNKNOWN flag error\n\r");
-#endif
-
-    /* Validate handle. */
-    if (pkt->handle < MAX_OUTSTANDING_COMMANDS)
-        sp = ha->outstanding_cmds[pkt->handle];
-    else
-        sp = 0;
-
-    if (sp)
-    {
-        /* Free outstanding command slot. */
-        ha->outstanding_cmds[pkt->handle] = 0;
-
-        /* Bad payload or header */
-        if (pkt->entry_status & (BIT_3 + BIT_2))
-        {
-            /* Bad payload or header, set error status. */
-            /* CMD_RESULT(sp->cmd) = CS_BAD_PAYLOAD; */
-            CMD_RESULT(sp->cmd) = (int) DID_ERROR << 16;
-        }
-        else if (pkt->entry_status & BIT_1 ) /* FULL flag */
-        {
-            CMD_RESULT(sp->cmd) = (int) DID_BUS_BUSY << 16;
-        }
-        else
-        {
-            /* Set error status. */
-            CMD_RESULT(sp->cmd) =(int)  DID_ERROR << 16;
-        }
-        /* Place command on done queue. */
-        qla1280_done_q_put(sp, done_q_first, done_q_last);
-    }
-#if  QLA1280_64BIT_SUPPORT
-    else if (pkt->entry_type == COMMAND_A64_TYPE)
-    {
-#ifdef QL_DEBUG_LEVEL_2
-        qla1280_print("qla1280_error_entry: ISP Invalid handle\n\r");
-#endif
-        printk(KERN_WARNING "!qla1280: Error Entry invalid handle");
-        ha->flags.isp_abort_needed = TRUE;
-    }
-#endif
+static void
+qla1280_error_entry(struct scsi_qla_host *ha, struct response * pkt,
+		    struct srb ** done_q_first, struct srb ** done_q_last)
+{
+	struct srb *sp;
+	uint32_t handle = le32_to_cpu(pkt->handle);
+
+	ENTER("qla1280_error_entry");
+
+	if (pkt->entry_status & BIT_3)
+		dprintk(2, "qla1280_error_entry: BAD PAYLOAD flag error\n");
+	else if (pkt->entry_status & BIT_2)
+		dprintk(2, "qla1280_error_entry: BAD HEADER flag error\n");
+	else if (pkt->entry_status & BIT_1)
+		dprintk(2, "qla1280_error_entry: FULL flag error\n");
+	else
+		dprintk(2, "qla1280_error_entry: UNKNOWN flag error\n");
 
-#ifdef QL_DEBUG_LEVEL_3
-    LEAVE("qla1280_error_entry");
+	/* Validate handle. */
+	if (handle < MAX_OUTSTANDING_COMMANDS)
+		sp = ha->outstanding_cmds[handle];
+	else
+		sp = 0;
+
+	if (sp) {
+		/* Free outstanding command slot. */
+		ha->outstanding_cmds[handle] = 0;
+
+		/* Bad payload or header */
+		if (pkt->entry_status & (BIT_3 + BIT_2)) {
+			/* Bad payload or header, set error status. */
+			/* CMD_RESULT(sp->cmd) = CS_BAD_PAYLOAD; */
+			CMD_RESULT(sp->cmd) = DID_ERROR << 16;
+		} else if (pkt->entry_status & BIT_1) {	/* FULL flag */
+			CMD_RESULT(sp->cmd) = DID_BUS_BUSY << 16;
+		} else {
+			/* Set error status. */
+			CMD_RESULT(sp->cmd) = DID_ERROR << 16;
+		}
+		/* Place command on done queue. */
+		qla1280_done_q_put(sp, done_q_first, done_q_last);
+	}
+#ifdef QLA_64BIT_PTR
+	else if (pkt->entry_type == COMMAND_A64_TYPE) {
+		printk(KERN_WARNING "!qla1280: Error Entry invalid handle");
+	}
 #endif
+
+	LEAVE("qla1280_error_entry");
 }
 
 /*
@@ -5911,236 +4729,91 @@
  * Returns:
  *      0 = success
  */
-STATIC uint8_t
-qla1280_abort_isp(scsi_qla_host_t *ha)
-{
-    device_reg_t    *reg = ha->iobase;
-    uint8_t         status = 0;
-    uint16_t        cnt;
-    srb_t           *sp;
-    scsi_lu_t       *q;
-    uint32_t        b, t, l;
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-    unsigned long cpu_flags = 0;
-#endif
-
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_abort_isp");
-#endif
-
-    DRIVER_LOCK
-            ha->flags.isp_abort_needed = FALSE;
-    if (!ha->flags.abort_isp_active && ha->flags.online)
-    {
-        ha->flags.abort_isp_active = TRUE;
-
-        /* Disable ISP interrupts. */
-        WRT_REG_WORD(&reg->ictrl, 0);
-
-        /* Dequeue all commands in outstanding command list. */
-        for (cnt = 1; cnt < MAX_OUTSTANDING_COMMANDS; cnt++)
-        {
-            sp = ha->outstanding_cmds[cnt];
-            if (sp)
-            {
-                ha->outstanding_cmds[cnt] = 0;
-
-                /* Generate LU queue on controller, target, LUN */
-                b = SCSI_BUS_32(sp->cmd);
-                t = SCSI_TCN_32(sp->cmd);
-                l = SCSI_LUN_32(sp->cmd);
-
-                q = (scsi_lu_t       *)LU_Q(ha, b, t, l);
-
-                /* Reset outstanding command count. */
-                q->q_outcnt = 0;
-                q->q_flag &= ~QLA1280_QBUSY;
-                q->q_flag =  0;
-
-                /* Adjust watchdog timer for command. */
-                /* if (sp->flags & SRB_WATCHDOG)
-                sp->timeout += 2; */
-
-                /* Place request back on top of device queue. */
-                /* sp->flags &= ~(SRB_SENT | SRB_TIMEOUT); */ 
-                sp->flags = 0;
-                qla1280_putq_t(q, sp);
-            }
-        }
-
-        /* If firmware needs to be loaded */
-        if (qla1280_isp_firmware(ha))
-        {
-            if (!(status = qla1280_chip_diag(ha)))
-                status = qla1280_setup_chip(ha); 
-        }
-
-        if (!status)
-        {
-            /* Setup adapter based on NVRAM parameters. */
-            qla1280_nvram_config(ha); 
-
-            if (!(status = qla1280_init_rings(ha)))
-            {
-                /* Issue SCSI reset. */
-                for (b = 0; b < ha->ports; b++)
-                {
-                    qla1280_bus_reset(ha, b);
-                }
-                do
-                {
-                    /* Issue marker command. */
-                    ha->flags.reset_marker = FALSE;
-                    for (b = 0; b < ha->ports; b++)
-                    {
-                        ha->bus_settings[b].reset_marker = FALSE;
-                        qla1280_marker(ha, b, 0, 0, MK_SYNC_ALL);
-                    }
-                }while (ha->flags.reset_marker);
-
-                /* Enable host adapter target mode. */
-                for (b = 0; b < ha->ports; b++)
-                {
-                    if (!(status = qla1280_enable_tgt(ha, b)))
-                    {
-                        for (cnt = 0; cnt < MAX_LUNS; cnt++)
-                        {
-                            /* qla1280_enable_lun(ha, b, cnt); */
-                            qla1280_poll(ha);
-                        }
-                    }
-                    else
-                        break;
-                }
-
-                if (!status)
-                { 
-                    /* Enable ISP interrupts. */
-                    WRT_REG_WORD(&reg->ictrl, ISP_EN_INT + ISP_EN_RISC);
-                    ha->flags.abort_isp_active = FALSE;
-                    /* Restart queues that may have been stopped. */
-                    qla1280_restart_queues(ha);
-                }
-            }
-        }
-    }
-
-    if (status)
-    {
-        printk(KERN_WARNING
-                "qla1280: ISP error recovery failed, board disabled");
-        qla1280_reset_adapter(ha);
-        qla1280_abort_queues(ha);
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-        qla1280_print("qla1280_abort_isp: **** FAILED ****\n\r");
-#endif
-    }
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        LEAVE("qla1280_abort_isp");
-#endif
-    DRIVER_UNLOCK
-
-            return(status);
-}
-
-/*
- *  qla1280_restart_queues
- *      Restart all device queues.
- *
- * Input:
- *      ha = adapter block pointer.
- */
-STATIC void
-qla1280_restart_queues(scsi_qla_host_t *ha)
+static int
+qla1280_abort_isp(struct scsi_qla_host *ha)
 {
-    scsi_lu_t *q;
-    uint32_t  b, t, l;
+	struct srb *sp;
+	int status = 0;
+	int cnt;
+	int bus;
 
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_restart_queues");
-#endif
-
-    for (b = 0; b < ha->ports; b++)
-        for (t = 0; t < MAX_TARGETS; t++)
-            for (l = 0; l < MAX_LUNS; l++)
-            {
-                q = (scsi_lu_t *) LU_Q(ha, b, t, l);
-                if (q != NULL)
-                {
-                    /* Acquire LU queue specific lock */
-                    QLA1280_SCSILU_LOCK(q);
+	ENTER("qla1280_abort_isp");
 
-                    if (q->q_first)
-                        qla1280_next(ha, q, b);
-                    else
-                        /* Release LU queue specific lock */
-                        QLA1280_SCSILU_UNLOCK(q);
-                }
-            }
-#ifdef QL_DEBUG_LEVEL_3
-            qla1280_print("qla1280_restart_queues: exiting normally\n");
-#endif
-}
+	if (!ha->flags.abort_isp_active && ha->flags.online) {
+		struct device_reg *reg = ha->iobase;
+		ha->flags.abort_isp_active = 1;
 
-/*
- *  qla1280_abort_queue_single
- *      Abort all commands on a device queues.
- *
- * Input:
- *      ha = adapter block pointer.
- */
-STATIC void qla1280_abort_queue_single(scsi_qla_host_t *ha,uint32_t b,uint32_t t,uint32_t l,uint32_t stat)
-{
-    scsi_lu_t *q;
-    srb_t     *sp, *sp_next; 
+		/* Disable ISP interrupts. */
+		qla1280_disable_intrs(ha);
+		WRT_REG_WORD(&reg->host_cmd, HC_PAUSE_RISC);
+		RD_REG_WORD(&reg->id_l);
 
-    ENTER("qla1280_abort_queue_single");
-    q = (scsi_lu_t * )LU_Q(ha, b, t, l);
-    if (q != NULL)
-    {
-        /* Acquire LU queue specific lock */
-        QLA1280_SCSILU_LOCK(q);
+		printk(KERN_INFO "scsi(%li): dequeuing outstanding commands\n",
+		       ha->host_no);
+		/* Dequeue all commands in outstanding command list. */
+		for (cnt = 0; cnt < MAX_OUTSTANDING_COMMANDS; cnt++) {
+			Scsi_Cmnd *cmd;
+			sp = ha->outstanding_cmds[cnt];
+			if (sp) {
+
+				cmd = sp->cmd;
+				CMD_RESULT(cmd) = DID_RESET << 16;
 
-        sp = q->q_first;
-        q->q_first = q->q_last = NULL;
+				sp->cmd = NULL;
+				ha->outstanding_cmds[cnt] = NULL;
 
-        QLA1280_SCSILU_UNLOCK(q);
+				(*cmd->scsi_done)(cmd);
 
-        while (sp)
-        {
-            sp_next = sp->s_next;
-            CMD_RESULT(sp->cmd) = stat;
-            qla1280_done_q_put(sp, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
-            sp = sp_next;
-        }
-    }
-    LEAVE("qla1280_abort_queue_single");
-}
+				sp->flags = 0;
+			}
+		}
 
-/*
- *  qla1280_abort_queues
- *      Abort all commands on device queues.
- *
- * Input:
- *      ha = adapter block pointer.
- */
-STATIC void
-qla1280_abort_queues(scsi_qla_host_t *ha)
-{
-    uint32_t  b, t, l;
+		/* If firmware needs to be loaded */
+		if (qla1280_isp_firmware (ha)) {
+			if (!(status = qla1280_chip_diag(ha)))
+				status = qla1280_setup_chip(ha);
+		}
 
-    ENTER("qla1280_abort_queues");
+		if (!status) {
+			/* Setup adapter based on NVRAM parameters. */
+			qla1280_nvram_config (ha);
+
+			if (!(status = qla1280_init_rings(ha))) {
+				/* Issue SCSI reset. */
+				for (bus = 0; bus < ha->ports; bus++) {
+					qla1280_bus_reset(ha, bus);
+				}
+				/*
+				 * qla1280_bus_reset() will do the marker
+				 * dance - no reason to repeat here!
+				 */
+#if  0
+				/* Issue marker command. */
+				ha->flags.reset_marker = 0;
+				for (bus = 0; bus < ha->ports; bus++) {
+					ha->bus_settings[bus].
+						reset_marker = 0;
+					qla1280_marker(ha, bus, 0, 0,
+						       MK_SYNC_ALL);
+				}
+#endif
+				ha->flags.abort_isp_active = 0;
+			}
+		}
+	}
 
-    for (b = 0; b < ha->ports; b++)
-        for (t = 0; t < MAX_TARGETS; t++)
-            for (l = 0; l < MAX_LUNS; l++)
-                qla1280_abort_queue_single(ha,b,t,l,DID_RESET);
+	if (status) {
+		printk(KERN_WARNING
+		       "qla1280: ISP error recovery failed, board disabled");
+		qla1280_reset_adapter(ha);
+		dprintk(2, "qla1280_abort_isp: **** FAILED ****\n");
+	}
 
-            LEAVE("qla1280_abort_queues");
+	LEAVE("qla1280_abort_isp");
+	return status;
 }
 
+
 /*
  * qla1280_debounce_register
  *      Debounce register.
@@ -6151,28 +4824,27 @@
  * Returns:
  *      register value.
  */
-STATIC uint16_t
-qla1280_debounce_register(volatile uint16_t *addr)
+static u16
+qla1280_debounce_register(volatile u16 * addr)
 {
-    volatile uint16_t ret;
-    volatile uint16_t ret2;
+	volatile u16 ret;
+	volatile u16 ret2;
 
-    do
-    {
-        ret = RD_REG_WORD(addr);
-        ret2 = RD_REG_WORD(addr);
-    }while (ret != ret2);
+	ret = RD_REG_WORD(addr);
+	ret2 = RD_REG_WORD(addr);
 
-    return(ret);
-}
+	if (ret == ret2)
+		return ret;
 
+	do {
+		cpu_relax();
+		ret = RD_REG_WORD(addr);
+		ret2 = RD_REG_WORD(addr);
+	} while (ret != ret2);
 
-/*
- * Declarations for load module
- */
-static Scsi_Host_Template driver_template = QLA1280_LINUX_TEMPLATE;
+	return ret;
+}
 
-#include "scsi_module.c"
 
 /************************************************************************
  * qla1280_check_for_dead_scsi_bus                                      *
